#include "VideoStream.h"
#include <windows.h>
#include <stdio.h>
#include <process.h>

VideoStream::VideoStream(const char* URL, const char* path, const char* fileName)
{
	videoURL = URL;
	videoPath = path;
	videoFileName = fileName;
	isRecordingFlag = false;
	rtspConnection = new ourRTSPConnection();
	ERRO = 0;
}

VideoStream::~VideoStream(void)
{
	if(isRecording()) {
		rtspConnection->shutDown();
	}
}

void VideoStream::initialize(int with, int heigth, int frame, int buffer)
{
	this->withStream = with;
	this->heigthStream = heigth;
	this->frameStream = frame;
	this->bufferStream = buffer;
}

void VideoStream::setPath(char const* path)
{
	videoPath = path;
}

void VideoStream::setErro(int erro)
{
	ERRO = erro;
}

void VideoStream::setFileName(char const* fileName)
{
	videoFileName = fileName;
}

const char* VideoStream::getPath(void)
{
	return videoPath;
}

const char* VideoStream::getURL(void)
{
	return videoURL;
}

int VideoStream::getErro(void)
{
	return ERRO;
}

const char* VideoStream::getFileName(void)
{
	return videoFileName;
}

bool VideoStream::isRecording(void)
{
	return isRecordingFlag;
}

void VideoStream::startRecord(void) throw (exception)
{
	try {
		if(!isRecording())
		{
			_beginthread(recordingThread,0,(void*)this);
		}
	} catch (exception& myException) {
		throw myException;
	}

}

void VideoStream::stopRecord(void) throw (exception)
{
	try {
		if(isRecording()) {
			rtspConnection->shutDown();
			isRecordingFlag = false;
		}
	} catch (exception& myException) {
		throw myException;
	}
}

void VideoStream::recordingThread(void* pParam) throw (exception)
{
	VideoStream* videoStream = (VideoStream*) pParam;
	try {
		videoStream->isRecordingFlag = true;
		videoStream->rtspConnection->initRTSP(videoStream->getURL(),videoStream->getPath(),videoStream->getFileName(), videoStream->withStream, videoStream->heigthStream, videoStream->frameStream, videoStream->bufferStream);
	} catch (exception& myException) {
		videoStream->isRecordingFlag = false;
	}
	return;
}

void VideoStream::erroThread(void* pParam)
{
	VideoStream* videoStream = (VideoStream*) pParam;
	Sleep(300000);
	if (videoStream != NULL)
		videoStream->setErro(0);
	return;
}