#pragma once
#include "ourRTSPConnection.h"

class VideoStream
{
public:
	VideoStream(char const* URL, char const* path, char const* fileName);
	~VideoStream(void);
	void setPath(char const* path);
	void setFileName(char const* fileName);
	void setErro(int erro);
	void initialize(int withStream, int heigthStream, int frameStream, int bufferStream);
	const char* getPath(void);
	const char* getURL(void);
	const char* getFileName(void);
	int getErro(void);
	bool isRecording(void);
	void startRecord(void) throw (exception);
	void stopRecord(void) throw (exception);
	static void recordingThread(void* pParam) throw (exception);
	static void erroThread(void* pParam);
	bool isRecordingFlag;
	ourRTSPConnection* rtspConnection;

private:
	const char* videoURL;
	const char* videoPath;
	const char* videoFileName;
	int withStream;
	int heigthStream;
	int frameStream;
	int bufferStream;
	int ERRO;
};

