#pragma once

#define RTSP_CLIENT_VERBOSITY_LEVEL 0

#include "rtspclient.hh"
#include "StreamClientState.h"
#include <exception>
using namespace std;


// RTSP 'Response Handlers':
void continueAfterDESCRIBE(RTSPClient* rtspClient, int resultCode, char* resultString) throw(exception);
void continueAfterSETUP(RTSPClient* rtspClient, int resultCode, char* resultString) throw(exception);
void continueAfterPLAY(RTSPClient* rtspClient, int resultCode, char* resultString) throw(exception);

// Outras funes Event Handler:
void subsessionAfterPlaying(void* clientData); // Chamada quando uma Subsession Stream acaba
void subsessionByeHandler(void* clientData); // Chamada quando um RTCP "BYE"  recebido por uma subsesso
void streamTimerHandler(void* clientData); // Chamada quando a durao esperada de uma Subssesion acaba

// Iterador de Subsessions Streams, configurando cada uma:
void setupNextSubsession(RTSPClient* rtspClient);

// Shut down uma stream (incluindo o "RTSPClient" object):
void shutdownStream(RTSPClient* rtspClient, int exitCode = 1);

UsageEnvironment& operator<<(UsageEnvironment& env, const RTSPClient& rtspClient);
UsageEnvironment& operator<<(UsageEnvironment& env, const MediaSubsession& subsession) ;



class ourRTSPClient : public RTSPClient
{
public:

	static ourRTSPClient* createNew(UsageEnvironment& env, char const* rtspURL, int verbosityLevel = 0,	char const* applicationName = NULL,
									portNumBits tunnelOverHTTPPortNum = 0);

	virtual ~ourRTSPClient();

protected:
	ourRTSPClient(UsageEnvironment& env, char const* rtspURL,
					int verbosityLevel, char const* applicationName, portNumBits tunnelOverHTTPPortNum);

public:
	StreamClientState scs;
};

