#pragma once
#include "ourRTSPClient.h"
#include <exception>
#include <map>

using namespace std;

class ourRTSPConnection
{
public:
	ourRTSPConnection(void);
	static ourRTSPConnection* getInstance(void);
	~ourRTSPConnection(void);
	int initRTSP(char const* url, char const* path, char const* fileName, int withRTSP, int heigthRTSP, int frameRTSP, int bufferRTSP) throw (exception);
	RTSPClient* openURL(UsageEnvironment& env, char const* progName, char const* rtspURL) throw(exception);
	static void packetsController(void* clientData) throw(exception);
	void shutDown(void) throw (exception);
	void setPath(const char* path) throw (exception);
	RTSPClient* ourRtspClient;

private:
	const char* ourURL;
};

